{--------- Small Unit for NEWS SPLITTER --------}
{ Written 1992 by Valery Votintsev              }
{-----------------------------------------------}
UNIT MyLib;
Interface

USES DOS;

Function Upper(Ch:Char):Char;               { Convert Char to UPPER case }
Function StUpCase(S:String):String;         { Convert String to UPPER case }
function FileExists(FileName: string): Boolean; { Returns True if file exists;
                                                 otherwise, it returns False }
Function DirExists(Strn:String):Boolean;    { Returns True if DIR exists;
                                              otherwise, it returns False }
Function BackPos(Ch:Char;Line:string):Byte; { Search Backward Position in
                                              string}
Function Ltrim(Strin:String):String;        { LEFT Trim }
Function Rtrim(Strin:String):String;        { RIGHT Trim }
{-----------------------------------------------}
Implementation

Function Upper(Ch:Char):Char;
{ Convert Char to UPPER case }

var

  OutCH: Char;

begin
  OutCh:=Ch;
  if (Ch>='a') and (Ch<='z') then OutCh:=Chr(Ord(Ch) - $20)
  else if (Ch>='' {rus}) and (Ch<='') then OutCh:=Chr(Ord(Ch) - $20)
    else if (Ch>='' {rus}) and (Ch<='') then OutCh:=Chr(Ord(Ch) - $50)
      else if (Ch='') then Ch:='';

 Upper:=OutCh;
end; { Upper }

{--------------  ---------------------------}
Function StUpCase(S:String):String;
var
  i : Integer;
begin
  for i := 1 to Length(s) do
    s[i] := Upper(s[i]);
  StUpCase:=S;
end;

{-----------------------------------------------}
function FileExists(FileName: string): Boolean;
{ Returns True if file exists; otherwise, it returns False }

var
    DirInfo: SearchRec;
begin
 FindFirst(Filename, Archive, DirInfo);
 FileExists:=(DosError = 0);
 doserror:=0;

end;  { FileExists }

{-----------------------------------------------------------}
Function DirExists(Strn:String):Boolean;
var
    DirInfo: SearchRec;
begin
 FindFirst(Strn, Directory, DirInfo);
 DirExists:=(DosError = 0);
end;


{-----------------------------------------------------------}
Function BackPos(Ch:Char;Line:string):Byte;
var
 Point:Byte;
 i:byte;
 l:byte absolute Line;

begin
 Point:=0;
 For i:=l downto 1 do begin
  If Line[i]=Ch then begin
    Point:=i;
    i:=1;
  end;
 end;
 BackPos:=Point;
end;

{-------------------------------------------------}
Function Ltrim(Strin:String):String;
Var
   Slen: Byte Absolute Strin;
   i,j:Byte;
Begin
 j:=1;
 For i:=1 to Slen do begin
  If Strin[i]=' ' then j:=i+1
  else i:=Slen;
 end;
 Ltrim:=Copy(Strin,j,Slen-j+1);
end; { }


{-------------------------------------------------}
Function Rtrim(Strin:String):String;
Var
   Slen: Byte Absolute Strin;
   i,j:Byte;
Begin
   j:=Slen;
   For i:=Slen downto 1 do begin
      If Strin[i]=' ' then j:=i-1
                      else i:=1;
   end;
   Rtrim:=Copy(Strin,1,j);
end; { }


end.


{----------- NS.PAS  -----------------------------------------------
News Splitter v.1.2. Written 1992 by Valery Votintsev
--------------------------------------------------------------------}
program NewsSplitter;

uses dos,crt,MyLib;
Const
   Test = False;
   Test_File='rtsb';

var
   Post,News,Conf:text;
   line:string;
   Len:byte absolute Line;
   i,j:byte;
   post_file:string;
   Conf_file:string;
   News_file:string;
   NewsGroup:String;
   Start:Boolean;
   List: Boolean;
   Group:String;
   Subject:String;
   aHeader:Array[1..50] of String;
   aNews:Array[1..30,1..2] of String;
   Header:Boolean;
   Nstr:byte;
   NewsNum:byte;
   ch:char;
   InPath:String;
   OutPath:String;

{-----------------------------------------------------------}
Procedure Config;
Var
   Line:string;
   Point:Byte;
   LineLen: byte absolute Line;
   InLen:  Byte Absolute InPath;
   OutLen: Byte Absolute OutPath;

begin
   Line:=ParamStr(0);
   For Point:=LineLen downto 1 do begin
      If Line[Point]='\' then begin
         LineLen:=Point;
         Point:=1;
      end;
   end;
   Conf_file:=Line+'NS.CFG';
   NewsNum:=0;

   assign(Conf,Conf_file);
   (*$I-*) reset(Conf); (*$I+*)
   if ioresult<>0 then begin
      writeln('*** Can''t Open file "',conf_file,'"');
      HALT(1)
   end;

   while not EOF(Conf) do begin
      Readln(Conf,Line);
      Line:=Rtrim(Line);
      Point:=Pos('!',line);
      If Point>0 then begin
         Delete(Line,1,1);
         Point:=Pos('in',line);
         If Point>0 then begin
            InPath:=Ltrim(Copy(Line,Point+2,LineLen-Point-1));
            If InPath[InLen]<>'\' then InPath:=InPath+'\';
         end;
         Point:=Pos('out',line);
         If Point>0 then begin
            OutPath:=Ltrim(Copy(Line,Point+3,LineLen-Point-2));
            If OutPath[OutLen]<>'\' then OutPath:=OutPath+'\';
         end;
      end else begin
         If LineLen>0 then begin
            NewsNum:=NewsNum+1;
            aNews[NewsNum,1]:='';
            aNews[NewsNum,2]:='';

            Point:=Pos(' ',line);
            aNews[NewsNum,1]:=Copy(Line,1,Point-1);
            Delete(line,1,Point);
            Line:=ltrim(Line);
            If LineLen>0 then aNews[NewsNum,2]:=Line;
         end;
      end;
   end;
   Close(Conf);
end;

{-----------------------------------------------------------------}
Procedure Init;
begin
   Writeln('News Splitter v.1.2, (c) 1992 by V.Votintsev, Info-Link, ltd.');
   If not Test then begin
      if ParamCount<1 then begin
         writeln('');
         writeln('Usage:   NS <MailBox> [/d]');
         writeln('where    MailBox - Mail File.');
         writeln('         /d - Delete source file.');
         writeln(' See file NS.DOC for detail.');
         Halt;
      end;
   end;

   If Test then Post_File:=Test_file
           else Post_file:=ParamStr(1);
   Start:=True;
   Header:=False;
   line:='';
   Group:='';
   Config;
   write('Working ...');

   assign(Post,InPath+post_file);
   (*$I-*) reset(Post); (*$I+*)
   if ioresult<>0 then begin
      writeln('*** Can''t Open file "',InPath+post_file,'"');
      HALT
   end;
end;

{-----------------------------------------------------------}
Function FileName(NewsGroup:String):String;
var
   strn:string;
   i:integer;
begin
   Strn:=OutPath+'others';
   For i:=1 to NewsNum do begin
      If Pos(aNews[i,1],NewsGroup)>0 then begin
         strn:=aNews[i,2];
         i:=NewsNum;
      end;
   end;
   FileName:=Strn;
end;

{-----------------------------------------------------------}
Procedure NewFile(Group:string);
var
   ext:string;
   i:integer;
   path:string;
   Point:Byte;
begin
   Path:='';
   If List then ext:='.lst'
           else ext:='.pst';
   If not Start then close(News);
   Start:=False;
   News_file:=FileName(Group);
   If Pos('.',News_File)=0 then News_file:=News_File+ext;

   Point:=BackPos('\',News_File);
   Path:=Copy(News_File,1,Point-1);

   If Length(Path)>0 then begin
      If not (DirExists(Path)) then begin
         {$I-}
         { Get directory name from command line }
         MkDir(Path);
         if IOResult <> 0 then begin
            WriteLn('*** Can''t create directory ',Path);
            Halt(1);
         end;
      end;
   end;

   assign(News,News_file);
   If FileExists(News_File) then begin
      append(News);
      If not List then begin
         For i:=1 to nstr do Writeln(News,aHeader[i]);
      end else begin
         If Group='others' then writeln(news,line);
      end;
   end else begin
      rewrite(News);
      For i:=1 to nstr do Writeln(News,aHeader[i]);
      If list then writeln(news,line);

   end;
   If list then writeln(news,line);
end;

{-----------------------------------------------------------}
Procedure DoHeader;
Var Stop:Boolean;
begin
   Header:=True;
   Subject:='';
   Group:='';
   NewsGroup:='';
   News_file:='';
   List:=False;
   nstr:=1;
   Stop:=False;
   aHeader[nstr]:=line;

   While not Stop do begin
      readln(Post,line);
      nstr:=nstr+1;
      aHeader[nstr]:=line;
      if copy(Line,1,9)='Subject: ' then begin
         Subject:=Copy(line,10,len-9);
         List:=(Subject='List of new USENET articles');
      end;
      If Copy(Line,1,12)='Newsgroups: ' then NewsGroup:=Copy(Line,13,Len-12);
      If Copy(Line,1,6)='GROUP ' then begin
         Group:=Copy(LINE,7,Len-6);
         nstr:=nstr-1;
      end;
      If list then Stop:=(Group<>'')
              else Stop:=(Line='');
   end;

   If List then NewFile(Group)
           else NewFile(NewsGroup);
end;

{===========================================================}
Begin
   Init;

   while (not EOF(Post)) do begin

      readln(Post,line);

      If (copy(line,1,5)='From ') then DoHeader
      else begin
         If List then begin
            If Copy(Line,1,6)='GROUP ' then begin
               Group:=Copy(LINE,7,Len-6);
               NewFile(Group);
            end else begin
               If line<>'' then writeln(News,line);
            end;
         end else writeln(News,line);
      end;

   end; {While not EOF}

   close(Post);
   close (news);
   If StUpcase(ParamStr(2))='/D' then Erase(Post);

   GotoXY(Wherex-3,Wherey);
   writeln('completed.');

End.


